use elasticsearch::Elasticsearch;
use elasticsearch::http::Url;
use elasticsearch::http::transport::TransportBuilder;
use elasticsearch::http::transport::SingleNodeConnectionPool;
use elasticsearch::IndexParts;
use serde_json::Value;
use elasticsearch::auth::Credentials;

pub struct ElasticConection {
        conection: Elasticsearch
}

impl ElasticConection {
    pub fn new() -> Result<Self, Box<dyn std::error::Error>> {
        let url = Url::parse("http://127.0.0.1:9200")?;
        let credentials = Credentials::Basic("elastic".into(), "HlvFaJ8jyDwASZ4Yy_f2".into());
        let connection_pool = SingleNodeConnectionPool::new(url);
        let transport = TransportBuilder::new(connection_pool)
            .auth(credentials)
            .build()?;
        Ok(Self{
            conection: Elasticsearch::new(transport),
        })
    }

    pub async fn send(&self, data: Value) -> bool {
        let response = self.conection
            .index(IndexParts::Index("nutbeat-0.1"))
            .body(data)
            .send()
            .await.unwrap();
        response.status_code().is_success()
    }
}

    
